<?php

/******************************************************************************
* SPortal.php                                                                 *
*******************************************************************************
* SP: Simple Portal for SMF                                                   *
* Software Version:           SMF 1.0                                         *
* Software by:                [SiNaN] (http://www.simplemachines.org/) 		*
* Copyright 2005-2007 by:     [SiNaN] (seser2004@hotmail.com)     		*
* Support, News, Updates at:  http://www.simplemachines.org/                  *
*******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

//Sportal init
function sportal_init()
{

	global $context, $mbname, $txt;

$context['page_title'] = $context['forum_name'];
}

function sportal()
{

	global $context, $mbname, $txt;

	loadLanguage('SPortal');
	loadTemplate('SPortal');
}

function sp_welcome()
{
	global $context, $txt, $scripturl, $settings, $memberContext, $modSettings, $member_id;

	$member_id = $context['user']['id'];
	loadMemberData($member_id);
	loadMemberContext($member_id);

	$memberContext[$member_id]['karma']['total'] = $memberContext[$member_id]['karma']['good'] - $memberContext[$member_id]['karma']['bad'];

}

function sp_latestMember($output_method = 'echo')
{
	global $db_prefix, $txt, $scripturl, $context, $memberContext, $latest_member_id;

	$latest_member_id = $context['common_stats']['latest_member']['id'];
	loadMemberData($latest_member_id);
	loadMemberContext($latest_member_id);
}


function sp_whosOnline()
{
	global $scripturl, $db_prefix, $user_info, $txt, $settings, $online;

	$result = db_query("
		SELECT
			lo.ID_MEMBER, lo.logTime, mem.realName, mem.memberName, mem.showOnline,
			mg.onlineColor, mg.ID_GROUP
		FROM {$db_prefix}log_online AS lo
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = lo.ID_MEMBER)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = IF(mem.ID_GROUP = 0, mem.ID_POST_GROUP, mem.ID_GROUP))", __FILE__, __LINE__);

	$online['users'] = array();
	$online['guests'] = 0;
	$online['hidden'] = 0;
	$online['buddies'] = 0;
	$show_buddies = !empty($user_info['buddies']);

	while ($row = mysql_fetch_assoc($result))
	{
		if (!isset($row['realName']))
			$online['guests']++;
		elseif (!empty($row['showOnline']) || allowedTo('moderate_forum'))
		{
			// Some basic color coding...
			if (!empty($row['onlineColor']))
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '" style="color: ' . $row['onlineColor'] . ';">' . $row['realName'] . '</a>';
			else
				$link = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>';

			// Bold any buddies.
			if ($show_buddies && in_array($row['ID_MEMBER'], $user_info['buddies']))
			{
				$online['buddies']++;
				$link = '<b>' . $link . '</b>';
			}

			$online['users'][$row['logTime'] . $row['memberName']] = array(
				'id' => $row['ID_MEMBER'],
				'username' => $row['memberName'],
				'name' => $row['realName'],
				'group' => $row['ID_GROUP'],
				'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => $link,
				'hidden' => empty($row['showOnline']),
				'is_last' => false,
			);
		}
		else
			$online['hidden']++;
	}
	mysql_free_result($result);

	if (!empty($online['users']))
	{
		krsort($online['users']);
		$userlist = array_keys($online['users']);
		$online['users'][$userlist[count($userlist) - 1]]['is_last'] = true;
	}
	$online['num_users'] = count($online['users']) + $online['hidden'];
	$online['total_users'] = $online['num_users'] + $online['guests'];
}

function sp_showPoll($topic = null)
{
	global $context, $db_prefix, $txt, $ID_MEMBER, $settings, $boardurl, $sc, $user_info, $modSettings, $poll, $total;

	$boardsAllowed = boardsAllowedTo('poll_view');


	if (empty($boardsAllowed))
		return array();

	if ($topic === null && isset($_REQUEST['ssi_topic']))
		$topic = (int) $_REQUEST['ssi_topic'];
	else
		$topic = (int) $topic;

	$request = db_query("
		SELECT
			p.ID_POLL, p.question, p.votingLocked, p.hideResults, p.expireTime, p.maxVotes, b.ID_BOARD
		FROM ({$db_prefix}topics AS t, {$db_prefix}polls AS p, {$db_prefix}boards AS b)
		WHERE p.ID_POLL = t.ID_POLL
			AND t.ID_TOPIC = $topic
			AND b.ID_BOARD = t.ID_BOARD
			AND $user_info[query_see_board]" . (!in_array(0, $boardsAllowed) ? "
			AND b.ID_BOARD IN (" . implode(', ', $boardsAllowed) . ")" : '') . "
		LIMIT 1", __FILE__, __LINE__);

	// Either this topic has no poll, or the user cannot view it.
	if (mysql_num_rows($request) == 0)
		return array();

	$row = mysql_fetch_assoc($request);
	mysql_free_result($request);

	// Check if they can vote.
	if (!empty($row['expireTime']) && $row['expireTime'] < time())
		$allow_vote = false;
	elseif ($user_info['is_guest'] || !empty($row['votingLocked']) || !allowedTo('poll_vote', array($row['ID_BOARD'])))
		$allow_vote = false;
	else
	{
		$request = db_query("
			SELECT ID_MEMBER
			FROM {$db_prefix}log_polls
			WHERE ID_POLL = $row[ID_POLL]
				AND ID_MEMBER = $ID_MEMBER
			LIMIT 1", __FILE__, __LINE__);
		$allow_vote = mysql_num_rows($request) == 0;
		mysql_free_result($request);
	}

	$request = db_query("
		SELECT COUNT(DISTINCT ID_MEMBER)
		FROM {$db_prefix}log_polls
		WHERE ID_POLL = $row[ID_POLL]", __FILE__, __LINE__);
	list ($total) = mysql_fetch_row($request);
	mysql_free_result($request);

	$request = db_query("
		SELECT ID_CHOICE, label, votes
		FROM {$db_prefix}poll_choices
		WHERE ID_POLL = $row[ID_POLL]", __FILE__, __LINE__);
	$options = array();
	$total_votes = 0;
	while ($rowChoice = mysql_fetch_assoc($request))
	{
		censorText($rowChoice['label']);

		$options[$rowChoice['ID_CHOICE']] = array($rowChoice['label'], $rowChoice['votes']);
		$total_votes += $rowChoice['votes'];
	}
	mysql_free_result($request);

	$poll = array(
		'id' => $row['ID_POLL'],
		'image' => empty($pollinfo['votingLocked']) ? 'poll' : 'locked_poll',
		'question' => $row['question'],
		'total_votes' => $total,
		'is_locked' => !empty($pollinfo['votingLocked']),
		'allow_vote' => $allow_vote,
		'topic' => $topic
	);

	// Calculate the percentages and bar lengths...
	$divisor = $total_votes == 0 ? 1 : $total_votes;
	foreach ($options as $i => $option)
	{
		$bar = floor(($option[1] * 100) / $divisor);
		$barWide = $bar == 0 ? 1 : floor(($bar * 5) / 4);
		$poll['options'][$i] = array(
			'id' => 'options-' . $i,
			'percent' => $bar,
			'votes' => $option[1],
			'bar' => '<span style="white-space: nowrap;"><img src="' . $settings['images_url'] . '/poll_left.gif" alt="" /><img src="' . $settings['images_url'] . '/poll_middle.gif" width="' . $barWide . '" height="12" alt="-" /><img src="' . $settings['images_url'] . '/poll_right.gif" alt="" /></span>',
			'option' => parse_bbc($option[0]),
			'vote_button' => '<input type="' . ($row['maxVotes'] > 1 ? 'checkbox' : 'radio') . '" name="options[]" id="options-' . $i . '" value="' . $i . '" class="check" />'
		);
	}

	$poll['allowed_warning'] = $row['maxVotes'] > 1 ? sprintf($txt['poll_options6'], $row['maxVotes']) : '';
}

function sp_boardStats()
{
	global $db_prefix, $txt, $scripturl, $modSettings, $settings, $totals;

	$totals = array(
		'members' => $modSettings['totalMembers'],
		'posts' => $modSettings['totalMessages'],
		'topics' => $modSettings['totalTopics']
	);

	$result = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}boards", __FILE__, __LINE__);
	list ($totals['boards']) = mysql_fetch_row($result);
	mysql_free_result($result);

	$result = db_query("
		SELECT COUNT(*)
		FROM {$db_prefix}categories", __FILE__, __LINE__);
	list ($totals['categories']) = mysql_fetch_row($result);
	mysql_free_result($result);
}

function sportal_copyright()
{
	echo 'SimplePortal v1.2 &copy; <a href="http://www.bizmuhacirler.com/" target="_blank">[SiNaN]</a>';
}

function sp_topPoster($topNumber = 5)
{
	global $db_prefix, $scripturl, $memberContext, $txt, $settings, $modSettings, $top_posters, $top_poster_id, $list_no;

	if ($topNumber === null)
		$topNumber = isset($_GET['limit']) ? (int) $_GET['limit'] : 5;

	$list_no=1;

	// Find the latest poster.
	$request = db_query("
		SELECT m.ID_MEMBER, m.realName, m.posts, m.avatar, a.ID_ATTACH, a.attachmentType, a.filename
		FROM ({$db_prefix}members as m)
			LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = m.ID_MEMBER)
		ORDER BY posts DESC
		LIMIT $topNumber", __FILE__, __LINE__);
	$top_posters = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request)) {
		if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
		{
			$sizes = url_image_size($row['avatar']);

			// Does your avatar still fit the maximum size?
			if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
			{
				// Fix it permanently!
				$row['avatar'] = '';
				updateMemberData($row['ID_MEMBER'], array('avatar' => '\'\''));
			}
		}

		//Collect the ids
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		$top_posters[] = array(
			'list' => $list_no++,
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'posts' => $row['posts'],
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			)
		);
	}
	mysql_free_result($request);

	//Add Colors to the link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($top_posters as $k => $p) {
			$profile = $color_profile[$p['id']];
			if(!empty($profile)) {
				$top_posters[$k]['link'] = $profile['link'];
			}
		}
	}
}

function sp_topBoards($num_top = 10)
{
	global $context, $settings, $db_prefix, $txt, $scripturl, $ID_MEMBER, $user_info, $modSettings, $boards;

	if ($num_top === null)
		$num_top = isset($_GET['limit']) ? (int) $_GET['limit'] : 10;

	// Find boards with lots of posts.
	$request = db_query("
		SELECT
			b.name, b.numPosts, b.ID_BOARD
		FROM {$db_prefix}boards AS b
		WHERE $user_info[query_see_board]" . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? "
			AND b.ID_BOARD != " . (int) $modSettings['recycle_board'] : '') . "
		ORDER BY b.numPosts DESC
		LIMIT $num_top", __FILE__, __LINE__);
	$boards = array();
	while ($row = mysql_fetch_assoc($request))
		$boards[] = array(
			'id' => $row['ID_BOARD'],
			'num_posts' => $row['numPosts'],
			'name' => $row['name'],
			'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['name'] . '</a>'
		);
	mysql_free_result($request);

	// If we have nothing to output, just jump out.
	if (empty($boards))
		return $boards;
}

function sp_topTopics($type = 'replies', $num_topics = 10)
{
	global $db_prefix, $txt, $scripturl, $ID_MEMBER, $user_info, $modSettings, $topics;

	if ($num_topics === null)
		$num_topics = isset($_GET['limit']) ? (int) $_GET['limit'] : 10;

	if ($modSettings['totalMessages'] > 100000)
	{
		$request = db_query("
			SELECT ID_TOPIC
			FROM {$db_prefix}topics
			WHERE num" . ($type != 'replies' ? 'Views' : 'Replies') . " != 0
			ORDER BY num" . ($type != 'replies' ? 'Views' : 'Replies') . " DESC
			LIMIT 100", __FILE__, __LINE__);
		$topic_ids = array();
		while ($row = mysql_fetch_assoc($request))
			$topic_ids[] = $row['ID_TOPIC'];
		mysql_free_result($request);
	}
	else
		$topic_ids = array();

	$request = db_query("
		SELECT m.subject, m.ID_TOPIC, t.numViews, t.numReplies
		FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m, {$db_prefix}boards AS b)
		WHERE m.ID_MSG = t.ID_FIRST_MSG
			AND t.ID_BOARD = b.ID_BOARD" . (!empty($topic_ids) ? "
			AND t.ID_TOPIC IN (" . implode(', ', $topic_ids) . ")" : '') . "
			AND $user_info[query_see_board]" . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? "
			AND b.ID_BOARD != $modSettings[recycle_board]" : '') . "
		ORDER BY t.num" . ($type != 'replies' ? 'Views' : 'Replies') . " DESC
		LIMIT $num_topics", __FILE__, __LINE__);
	$topics = array();
	while ($row = mysql_fetch_assoc($request))
	{
		censorText($row['subject']);

		$topics[] = array(
			'id' => $row['ID_TOPIC'],
			'subject' => $row['subject'],
			'num_replies' => $row['numReplies'],
			'num_views' => $row['numViews'],
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['subject'] . '</a>',
		);
	}
	mysql_free_result($request);

	if (empty($topics))
		return $topics;

}

function sp_recentPosts($num_recent = 8, $exclude_boards = null)
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $ID_MEMBER;
	global $user_info, $modSettings, $func, $posts;

	if ($num_recent === null)
		$num_recent = isset($_GET['limit']) ? (int) $_GET['limit'] : 1;

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, m.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, m.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon
		FROM ({$db_prefix}messages AS m, {$db_prefix}boards AS b)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = m.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = m.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE m.ID_MSG >= " . ($modSettings['maxMsgID'] - 25 * min($num_recent, 5)) . "
			AND b.ID_BOARD = m.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
			AND $user_info[query_see_board]
		ORDER BY m.ID_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
	$posts = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
		if ($func['strlen']($row['body']) > 128)
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Censor it!
		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['ID_TOPIC'],
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#msg' . $row['ID_MSG'] . '">' . $row['subject'] . '</a>',
			'new' => !empty($row['isRead']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
	mysql_free_result($request);
	
	//Add Colors to the Output link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($posts as $k => $p) {
			$profile = $color_profile[$p['poster']['id']];
			if(!empty($profile)) {
				$posts[$k]['poster']['link'] = $profile['link'];
			}
		}
	}

	// Just return it.
	if (empty($posts))
		return $posts;
}

function sp_recentTopics($num_recent = 8, $exclude_boards = null)
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $ID_MEMBER;
	global $user_info, $modSettings, $func, $posts;

	if ($num_recent === null)
		$num_recent = isset($_GET['limit']) ? (int) $_GET['limit'] : 1;

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : $exclude_boards;

	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = db_query("
		SELECT
			m.posterTime, ms.subject, m.ID_TOPIC, m.ID_MEMBER, m.ID_MSG, b.ID_BOARD, b.name AS bName,
			IFNULL(mem.realName, m.posterName) AS posterName, " . ($user_info['is_guest'] ? '1 AS isRead, 0 AS new_from' : '
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, 0)) >= m.ID_MSG_MODIFIED AS isRead,
			IFNULL(lt.ID_MSG, IFNULL(lmr.ID_MSG, -1)) + 1 AS new_from') . ", LEFT(m.body, 384) AS body, m.smileysEnabled, m.icon
		FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t, {$db_prefix}boards AS b, {$db_prefix}messages AS ms)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)" . (!$user_info['is_guest'] ? "
			LEFT JOIN {$db_prefix}log_topics AS lt ON (lt.ID_TOPIC = t.ID_TOPIC AND lt.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}log_mark_read AS lmr ON (lmr.ID_BOARD = b.ID_BOARD AND lmr.ID_MEMBER = $ID_MEMBER)" : '') . "
		WHERE t.ID_LAST_MSG >= " . ($modSettings['maxMsgID'] - 35 * min($num_recent, 5)) . "
			AND t.ID_LAST_MSG = m.ID_MSG
			AND b.ID_BOARD = t.ID_BOARD" . (empty($exclude_boards) ? '' : "
			AND b.ID_BOARD NOT IN (" . implode(', ', $exclude_boards) . ")") . "
			AND $user_info[query_see_board]
			AND ms.ID_MSG = t.ID_FIRST_MSG
		ORDER BY t.ID_LAST_MSG DESC
		LIMIT $num_recent", __FILE__, __LINE__);
	$posts = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']), array('<br />' => '&#10;')));
		if ($func['strlen']($row['body']) > 128)
			$row['body'] = $func['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['ID_BOARD'],
				'name' => $row['bName'],
				'href' => $scripturl . '?board=' . $row['ID_BOARD'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['ID_BOARD'] . '.0">' . $row['bName'] . '</a>'
			),
			'topic' => $row['ID_TOPIC'],
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => empty($row['ID_MEMBER']) ? '' : $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.msg' . $row['ID_MSG'] . '#new">' . $row['subject'] . '</a>',
			'new' => !empty($row['isRead']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
		);
	}
	mysql_free_result($request);
	
	//Add Colors to the Output link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($posts as $k => $p) {
			$profile = $color_profile[$p['poster']['id']];
			if(!empty($profile)) {
				$posts[$k]['poster']['link'] = $profile['link'];
			}
		}
	}

	$context['recent_topics']=$posts;

	// Just return it.
	if (empty($posts))
		return $posts;
}

function sp_boardNews($board = null, $limit = null, $start = null, $length = null)
{
	global $scripturl, $db_prefix, $txt, $settings, $modSettings, $context;
	global $func, $return;

	loadLanguage('Stats');

	// Must be integers....
	if ($limit === null)
		$limit = isset($_GET['limit']) ? (int) $_GET['limit'] : 5;
	else
		$limit = (int) $limit;

	if ($start === null)
		$start = isset($_GET['start']) ? (int) $_GET['start'] : 0;
	else
		$start = (int) $start;

	if ($board !== null)
		$board = (int) $board;
	elseif (isset($_GET['board']))
		$board = (int) $_GET['board'];

	if ($length === null)
		$length = isset($_GET['length']) ? (int) $_GET['length'] : 0;
	else
		$length = (int) $length;

	$limit = max(0, $limit);
	$start = max(0, $start);

	// Make sure guests can see this board.
	$request = db_query("
		SELECT ID_BOARD
		FROM {$db_prefix}boards
		WHERE " . ($board === null ? '' : "ID_BOARD = $board
			AND ") . "FIND_IN_SET(-1, memberGroups)
		LIMIT 1", __FILE__, __LINE__);
	if (mysql_num_rows($request) == 0)
	{
		die($txt['smf_news_error2']);
	}
	list ($board) = mysql_fetch_row($request);
	mysql_free_result($request);

	// Load the message icons - the usual suspects.
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find the post ids.
	$request = db_query("
		SELECT ID_FIRST_MSG
		FROM {$db_prefix}topics
		WHERE ID_BOARD = $board
		ORDER BY ID_FIRST_MSG DESC
		LIMIT $start, $limit", __FILE__, __LINE__);
	$posts = array();
	while ($row = mysql_fetch_assoc($request))
		$posts[] = $row['ID_FIRST_MSG'];
	mysql_free_result($request);

	if (empty($posts))
		return array();

	// Find the posts.
	$request = db_query("
		SELECT
			m.icon, m.subject, m.body, IFNULL(mem.realName, m.posterName) AS posterName, m.posterTime,
			t.numReplies, t.ID_TOPIC, m.ID_MEMBER, m.smileysEnabled, m.ID_MSG, t.locked, mem.avatar, a.ID_ATTACH, a.attachmentType, a.filename
		FROM ({$db_prefix}topics AS t, {$db_prefix}messages AS m)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
			LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = m.ID_MEMBER)
		WHERE t.ID_FIRST_MSG IN (" . implode(', ', $posts) . ")
			AND m.ID_MSG = t.ID_FIRST_MSG
		ORDER BY t.ID_FIRST_MSG DESC
		LIMIT " . count($posts), __FILE__, __LINE__);
	$return = array();
	$colorids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		// If we want to limit the length of the post.
		if (!empty($length) && $func['strlen']($row['body']) > $length)
		{
			$row['body'] = $func['substr']($row['body'], 0, $length);

			// The first space or line break. (<br />, etc.)
			$cutoff = max(strrpos($row['body'], ' '), strrpos($row['body'], '<'));

			if ($cutoff !== false)
				$row['body'] = $func['substr']($row['body'], 0, $cutoff);
			$row['body'] .= '...';
		}

		$row['body'] = parse_bbc($row['body'], $row['smileysEnabled'], $row['ID_MSG']);
		
		if (stristr($row['avatar'], 'http://') && !empty($modSettings['avatar_check_size']))
		{
			$sizes = url_image_size($row['avatar']);

			// Does your avatar still fit the maximum size?
			if ($modSettings['avatar_action_too_large'] == 'option_refuse' && is_array($sizes) && (($sizes[0] > $modSettings['avatar_max_width_external'] && !empty($modSettings['avatar_max_width_external'])) || ($sizes[1] > $modSettings['avatar_max_height_external'] && !empty($modSettings['avatar_max_height_external']))))
			{
				// Fix it permanently!
				$row['avatar'] = '';
				updateMemberData($row['ID_MEMBER'], array('avatar' => '\'\''));
			}
		}

		// Check that this message icon is there...
		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		censorText($row['subject']);
		censorText($row['body']);
		
		//Collect the color ids :)
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];

		$return[] = array(
			'id' => $row['ID_TOPIC'],
			'message_id' => $row['ID_MSG'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" border="0" />',
			'subject' => $row['subject'],
			'time' => timeformat($row['posterTime']),
			'timestamp' => forum_time(true, $row['posterTime']),
			'body' => $row['body'],
			'href' => $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['ID_TOPIC'] . '.0">' . $row['numReplies'] . ' ' . ($row['numReplies'] == 1 ? $txt['smf_news_1'] : $txt['smf_news_2']) . '</a>',
			'replies' => $row['numReplies'],
			'comment_href' => !empty($row['locked']) ? '' : $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'],
			'comment_link' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . ';num_replies=' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'new_comment' => !empty($row['locked']) ? '' : '<a href="' . $scripturl . '?action=post;topic=' . $row['ID_TOPIC'] . '.' . $row['numReplies'] . '">' . $txt['smf_news_3'] . '</a>',
			'poster' => array(
				'id' => $row['ID_MEMBER'],
				'name' => $row['posterName'],
				'href' => !empty($row['ID_MEMBER']) ? $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] : '',
				'link' => !empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>' : $row['posterName']
			),
			'locked' => !empty($row['locked']),
			'is_last' => false,
			'avatar' => array(
				'name' => $row['avatar'],
				'image' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? '<img src="' . (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
				'href' => $row['avatar'] == '' ? ($row['ID_ATTACH'] > 0 ? (empty($row['attachmentType']) ? $scripturl . '?action=dlattach;attach=' . $row['ID_ATTACH'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
				'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			),
		);
	}
	mysql_free_result($request);

	if (empty($return))
		return $return;

	$return[count($return) - 1]['is_last'] = true;
	//Add Colors to the Output link :)
	if(!empty($colorids)) {
		global $color_profile;
		sp_loadColors($colorids);
		foreach($return as $k => $p) {
			$color_profile[0] = '';
			$profile = $color_profile[$p['poster']['id']];
			if(!empty($profile)) {
				$return[$k]['poster']['link'] = $profile['link'];
			}
		}
	}

}

function sp_shop()
{
	global $db_prefix, $context;
	
		// Grab the purchase history
		// Start with empty list
		$context['shop_purchHis'] = array();
		// Get the details of purchases
		$request = db_query("
			SELECT ownerid, itemid, amtpaid, it.desc, it.image, it.id
			FROM {$db_prefix}shop_purchHis, {$db_prefix}shop_items AS it
			WHERE itemid = it.id
			ORDER BY ownerid DESC
			LIMIT 20", __FILE__, __LINE__);
		// Loop through all results
		while ($row = mysql_fetch_array($request, MYSQL_ASSOC))
			// And add them to the list
			$context['shop_purchHis'][] = array(
				'ownerid' => $row['ownerid'],
				'itemid' => $row['itemid'],
				'amtpaid' => $row['amtpaid'],
				'desc' => $row['desc'],
				'image' => $row['image']	
			);
			
		mysql_free_result($request);
}

function sp_gallery()
{
	global $modSettings, $context, $user_info, $scripturl, $sc, $ID_MEMBER, $db_prefix, $GD_Installed, $gallery_picture;

	$GD_Installed = function_exists('imagecreate');

	$dbresult = db_query("
		SELECT p.ID_PICTURE
		FROM {$db_prefix}gallery_pic as p
		ORDER BY ID_PICTURE DESC
		LIMIT 1", __FILE__, __LINE__);

	$max = mysql_fetch_assoc($dbresult);
	$check = 0;

	while($check == 0) {

		if ($modSettings['gallerytype'] == 0)
			$idpic = rand(1, $max['ID_PICTURE']);
		else
			$idpic = $max['ID_PICTURE'];

		$dbresult = db_query("
			SELECT p.ID_PICTURE, p.commenttotal, p.filesize, p.views, p.thumbfilename, p.filename, p.height, p.width, p.title, p.ID_MEMBER,
		m.memberName, m.realName, p.date, p.description
			FROM {$db_prefix}gallery_pic as p
			LEFT JOIN {$db_prefix}members AS m on ( p.ID_MEMBER = m.ID_MEMBER)
			WHERE p.approved = 1 AND p.ID_PICTURE = $idpic
			ORDER BY ID_PICTURE DESC", __FILE__, __LINE__);
		$gallery_picture = array();
		while($row = mysql_fetch_assoc($dbresult))
			{
				$gallery_picture = array (
					'id' => $row['ID_PICTURE'],
					'title' => $row['title'],
					'views' => $row['views'],
					'senderid' => $row['ID_MEMBER'],
					'sendername' => $row['realName'],
					'thumbfilename' => $row['thumbfilename'],
					'filename' => $row['filename']
				);
			}
		
			mysql_free_result($dbresult);		
	
		if(!empty($gallery_picture) || $modSettings['gallerytype'] != 0 || empty($max))
			$check = 1;
	}
}

function sp_arcade()
{
	global $boardurl, $sourcedir, $modSettings, $scripturl, $db_prefix, $arcade, $best_players;

	require_once($sourcedir.'/ArcadeStats.php');

	$sql = "SELECT game.ID_GAME, game.gameName, game.thumbnail, game.gameDirectory,
    	    IFNULL(mem.ID_MEMBER, 0) AS ID_MEMBER, IFNULL(mem.realName,'') AS realName, score.score 
        	FROM {$db_prefix}arcade_scores AS score
	        LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = score.ID_MEMBER)
    	    JOIN {$db_prefix}arcade_games AS game ON (game.ID_GAME = score.ID_GAME)
        	ORDER BY `championFrom` DESC
	        LIMIT 0,1";
	if(!($result = db_query($sql,__FILE__,__LINE__)))
	{
		die("Could not get the newest champ");
	}
	$row = mysql_fetch_assoc($result);
	mysql_free_result($result);

	if(isset($row['gameDirectory']))
	{
		$row['gameDirectory']=$row['gameDirectory']."/";
	}
	$arcade = array();
	$arcade = array (
		'playerid' => $row['ID_MEMBER'],
		'player' => $row['realName'],
		'game_id' => $row['ID_GAME'],
		'game_name' => $row['gameName'],
		'score' => $row['score'],
		'game_pic' => $modSettings['gamesUrl'] . "/" . $row['gameDirectory'].$row['thumbnail'],
		);

	$best_players=ArcadeStats_BestPlayers($modSettings['arcadebpcount']);

	$score_poss=0;
}

//This is  a small Skript to load colors for ssi
function sp_loadColors($users = array()) {
	global $color_profile, $db_prefix, $scripturl;

	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	//First check is it already loaded?
	if(empty($color_profile))
		$color_profile = array();
	else {
		foreach($users as $k => $u)
			if(isset($color_profile[$u]))
				unset($users[$k]);
	}
	
	if (empty($users))
		return false;

	// Load the data.
	$request = db_query("
		SELECT 
		mem.ID_MEMBER, mem.memberName, mem.realName, mem.ID_GROUP,
		mg.onlineColor AS member_group_color, pg.onlineColor AS post_group_color
		FROM {$db_prefix}members AS mem 
		LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
		LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
		WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

	$loaded_ids = array();
	while ($row = mysql_fetch_assoc($request))
	{
		$loaded_ids[] = $row['ID_MEMBER'];
		$color_profile[$row['ID_MEMBER']] = $row;
		$color_profile[$row['ID_MEMBER']]['link'] = '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . (!empty($row['member_group_color']) || !empty($row['post_group_color']) ? '<span style="color:'. (!empty($row['member_group_color']) ? $row['member_group_color'] : $row['post_group_color'] ) .';">' : '' ) . $row['realName'] . (!empty($row['member_group_color']) || !empty($row['post_group_color']) ? '</span>' : '' ).'</a>';
	}
	mysql_free_result($request);

	return empty($loaded_ids) ? false : $loaded_ids;
}

?>
